package org.jbpm.examples.eventlistener;

import java.util.ArrayList;
import java.util.List;

import org.jbpm.api.Execution;
import org.jbpm.api.ProcessInstance;
import org.jbpm.test.JbpmTestCase;


public class EventListenerTest extends JbpmTestCase {
  
  long deploymentDbid;
  
  protected void setUp() throws Exception {
    super.setUp();
    
    deploymentDbid = repositoryService.createDeployment()
        .addResourceFromClasspath("org/jbpm/examples/eventlistener/process.jpdl.xml")
        .deploy();
  }

  protected void tearDown() throws Exception {
    repositoryService.deleteDeploymentCascade(deploymentDbid);
    
    super.tearDown();
  }

  public void testEventListener() {
    ProcessInstance processInstance = executionService.startProcessInstanceByKey("EventListener");
    
    Execution execution = processInstance.findActiveExecutionIn("wait");
    executionService.signalExecutionById(execution.getId());
    
    List<String> expectedLogs = new ArrayList<String>();
    expectedLogs.add("event(start) on process(EventListener)");
    expectedLogs.add("event(start) on activity(wait)");
    expectedLogs.add("event(end) on activity(wait)");
    expectedLogs.add("event(take) on (wait)-->(park)");
    
    List<String> logs = (List<String>) executionService.getVariable(processInstance.getId(), "logs");
    
    assertEquals(expectedLogs, logs);
  }
}
