/*
 * JBoss, Home of Professional Open Source
 * Copyright 2005, JBoss Inc., and individual contributors as indicated
 * by the @authors tag. See the copyright.txt in the distribution for a
 * full listing of individual contributors.
 *
 * This is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation; either version 2.1 of
 * the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this software; if not, write to the Free
 * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA, or see the FSF site: http://www.fsf.org.
 */
package org.jbpm.pvm.internal.task;

import java.io.Serializable;
import java.util.List;

import org.jbpm.pvm.internal.util.Priority;
import org.jbpm.pvm.internal.wire.Descriptor;

/**
 * defines a task and how the actor(s) must be calculated at runtime.
 */
public class TaskDefinitionImpl extends AssignableDefinitionImpl implements Serializable {
  
  private static final long serialVersionUID = 1L;

  protected String dueDateDuration;
  protected String form;
  protected List<TaskDefinitionImpl> subTaskDefinitions;
  protected int priority = Priority.NORMAL;
  protected SwimlaneDefinitionImpl swimlaneDefinition;
  protected Descriptor taskHandlerDescriptor;

  public int getPriority() {
    return priority;
  }
  public void setPriority(int priority) {
    this.priority = priority;
  }
  public List<TaskDefinitionImpl> getSubTaskDefinitions() {
    return subTaskDefinitions;
  }
  public void setSubTaskDefinitions(List<TaskDefinitionImpl> subTaskDefinitions) {
    this.subTaskDefinitions = subTaskDefinitions;
  }
  public SwimlaneDefinitionImpl getSwimlaneDefinition() {
    return swimlaneDefinition;
  }
  public void setSwimlaneDefinition(SwimlaneDefinitionImpl swimlaneDefinition) {
    this.swimlaneDefinition = swimlaneDefinition;
  }
  public String getDueDateDuration() {
    return dueDateDuration;
  }
  public void setDueDateDuration(String dueDateDuration) {
    this.dueDateDuration = dueDateDuration;
  }
  public String getForm() {
    return form;
  }
  public void setForm(String form) {
    this.form = form;
  }
  public Descriptor getTaskHandlerDescriptor() {
    return taskHandlerDescriptor;
  }
  public void setTaskHandlerDescriptor(Descriptor taskHandlerDescriptor) {
    this.taskHandlerDescriptor = taskHandlerDescriptor;
  }
}
